﻿using Infragistics.Documents.Excel;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGExcelExportCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = new ViewModel();
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            XDG1.FieldLayouts[0].Fields[2].Visibility = Visibility.Collapsed;
            DataPresenterExcelExporter exporter = new DataPresenterExcelExporter();
            exporter.CellExporting += exporter_CellExporting;
            exporter.CellExported += exporter_CellExported;
            exporter.Export(XDG1, "xamDataGrid1.xlsx", WorkbookFormat.Excel2007);
            XDG1.FieldLayouts[0].Fields[2].Visibility = Visibility.Visible;        
        }

        void exporter_CellExported(object sender, CellExportedEventArgs e)
        {
            if (e.Field.Name.Contains("Mileage"))
            {
                double miles = ((FoodClass)e.Record.DataItem).Mileage;

                if (miles >= 1000)
                {
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = ((miles / 1000)).ToString() + " km";

                }
                else
                {
                    e.CurrentWorksheet.Rows[e.CurrentRowIndex].Cells[e.CurrentColumnIndex].Value = miles.ToString() + " m";
                }            
            }
        }
        void exporter_CellExporting(object sender, CellExportingEventArgs e)
        {
            if ((e.Field.DataType == typeof(double) || e.Field.DataType == typeof(int)) && e.Field.Name != "Mileage")
            {
                e.FormatSettings.FormatString = "#E+0";                
            }          
        }       
    }
}
